## ros-humble-play-motion2 0.0.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(play_motion2)

find_package(ament_cmake_auto REQUIRED)
ament_auto_find_build_dependencies()

# play_motion2
ament_auto_add_library(play_motion2 SHARED
  src/play_motion2/play_motion2_helpers.cpp
  src/play_motion2/play_motion2.cpp
)

# play_motion2_node
ament_auto_add_executable(play_motion2_node
  src/play_motion2_main.cpp
)

if(BUILD_TESTING)
  ament_auto_find_test_dependencies()
  ament_lint_auto_find_test_dependencies()

  # test configuration files
  install(
    FILES
      test/config.yaml
      test/play_motion2_config.yaml
      test/rrbot/controller_1.launch.py
      test/rrbot/controller_1.yaml
      test/rrbot/controller_2.launch.py
      test/rrbot/controller_2.yaml
      test/rrbot/controller_manager.yaml
      test/rrbot/controllers.launch.py
      test/rrbot/joint_state_broadcaster.launch.py
      test/rrbot/joint_state_broadcaster.yaml
      test/rrbot/rrbot.launch.py
      test/rrbot/rrbot.rviz
      test/rrbot/rrbot.xacro
    DESTINATION share/${PROJECT_NAME}/test
  )

  # rrbot_system
  ament_auto_add_library(rrbot_system SHARED
    test/rrbot/rrbot_system.cpp
  )
  # need to target because they are test dependencies
  ament_target_dependencies(rrbot_system
    hardware_interface
    pluginlib
  )
  pluginlib_export_plugin_description_file(hardware_interface test/rrbot/rrbot_system.xml)

  # play_motion2_helpers_test
  ament_auto_add_gtest(play_motion2_helpers_test
    test/play_motion2_helpers_test.cpp
  )

  # play_motion2_test
  ament_auto_add_gtest(play_motion2_test
    test/play_motion2_test.cpp
  )

  # play_motion2_node_test
  ament_add_gtest_executable(play_motion2_node_test
    test/play_motion2_node_test.cpp
  )
  ament_target_dependencies(play_motion2_node_test
    controller_manager_msgs
    launch_testing_ament_cmake
    play_motion2_msgs
    rclcpp
    rclcpp_action
  )

  install(
    TARGETS play_motion2_node_test
    DESTINATION share/${PROJECT_NAME}/test
  )

  add_launch_test(
    test/play_motion2_node_test.launch.py
  )
endif()

ament_auto_package(INSTALL_TO_SHARE launch)

=== debian/changelog ===
ros-humble-play-motion2 (0.0.9-1jammy) jammy; urgency=high

  * Use callback groups and MultiThreadedExecutor to execute callbacks in parallel
  * Contributors: Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Wed, 05 Jul 2023 00:00:00 -0000

ros-humble-play-motion2 (0.0.8-1jammy) jammy; urgency=high

  * add 1 extra second to motions timeout
    To avoid that motions with only one position fail when the robot is
    already in that position
  * fill error field and be more verbose
  * cancel action goals when requested
  * Contributors: Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Mon, 22 May 2023 00:00:00 -0000

ros-humble-play-motion2 (0.0.7-1jammy) jammy; urgency=high

  * remove meta information from mandatory parameters
  * Contributors: Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Mon, 17 Apr 2023 00:00:00 -0000

ros-humble-play-motion2 (0.0.6-1jammy) jammy; urgency=high

  * Merge branch 'remove_tests_namespace' into 'humble-devel'
    remove namespaces from tests
    See merge request app-tools/play_motion2!22
  * remove namespaces from tests
  * Merge branch 'fix_warns' into 'humble-devel'
    Fix warnings
    See merge request app-tools/play_motion2!21
  * not catch exception by value
  * change types for comparisons
  * comment unused arguments
  * order variables initialization
  * Merge branch 'wait_for_service_and_action' into 'humble-devel'
    wait for service and action after creating clients
    See merge request app-tools/play_motion2!20
  * wait for service and action after creating clients
  * Merge branch 'ament_cmake_auto' into 'humble-devel'
    switch to ament_cmake_auto
    See merge request app-tools/play_motion2!19
  * switch to ament_cmake_auto
  * Merge branch 'rm_ament_cmake_pal' into 'humble-devel'
    remove ament_cmake_pal
    See merge request app-tools/play_motion2!18
  * remove ament_cmake_pal
  * Contributors: Jordan Palacios, Mathias Lüdtke, Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Mon, 20 Mar 2023 00:00:00 -0000

ros-humble-play-motion2 (0.0.5-1jammy) jammy; urgency=high

  * Merge branch 'add_missing_dependency' into 'humble-devel'
    add missing test dependency robot_state_publisher and remove initial / from controllers config
    See merge request app-tools/play_motion2!17
  * remove initial / from controllers config
  * add missing test dependency robot_state_publisher
  * Contributors: Jordan Palacios, Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Wed, 01 Mar 2023 00:00:00 -0000

ros-humble-play-motion2 (0.0.4-1jammy) jammy; urgency=high

  * Merge branch 'fix_test' into 'humble-devel'
    Fix unstable test
    See merge request app-tools/play_motion2!16
  * set start timeout in a variable
  * use a better assert
  * fix gtest header
  * remove unused header
  * fix loop condition to start play_motion2_node_test
  * Contributors: Jordan Palacios, Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Thu, 23 Feb 2023 00:00:00 -0000

ros-humble-play-motion2 (0.0.3-1jammy) jammy; urgency=high

  * Merge branch 'fix_cache_concurrency' into 'humble-devel'
    Do not update controller states cache if play_motion2 is busy
    See merge request app-tools/play_motion2!13
  * do not update controller states cache if play_motion2 is busy
  * Contributors: Jordan Palacios, Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Wed, 15 Feb 2023 00:00:00 -0000

ros-humble-play-motion2 (0.0.2-1jammy) jammy; urgency=high



 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Wed, 08 Feb 2023 00:00:00 -0000

ros-humble-play-motion2 (0.0.1-1jammy) jammy; urgency=high

  * Merge branch 'fix_loop_condition' into 'humble-devel'
    Fix inifinite retries loop and testing double types
    See merge request app-tools/play_motion2!11
  * replace ASSERT_EQ with ASSERT_DOUBLE_EQ for doubles
  * fix inifinite retries loop
  * Merge branch 'approach_first_position' into 'humble-devel'
    Approach to first position
    See merge request app-tools/play_motion2!10
  * rm possible concurrency and unnecessary unlock
  * tests syntax fixes
  * test to check motions on site and to other positions
  * approach to the first position
  * Merge branch 'motion_results' into 'humble-devel'
    Wait for action results
    See merge request app-tools/play_motion2!8
  * add missing const, fix parameter name
  * simplify play_motion2_node tests into smaller functions
  * simplify function
  * change logs order
  * update controller states method
  * renaming and move future instead of make a copy
  * comment destructor behaviour
  * test for controller deactivated after sending all goals
  * handle action errors, exceptions
  * check controller states while executing motion
  * test for controller deactivated while executing motion
  * set use_sim_time for tests
  * bug fix: motion suceeded when a controller was deactivated after the goal was accepted
  * remove wrong redefinition
  * rewrite timeout and add error log
  * fix timeout calculation
  * add timeout when waiting for results
  * split rrbot jtc in 2 for tests
  * rename parameter
  * make error log more specific
  * simplify condition
  * store and join execution thread
  * fix tests times_from_start param
  * wait for results
  * Merge branch 'jtc_motions' into 'humble-devel'
    Send JTC motions (without waiting for the result)
    See merge request app-tools/play_motion2!7
  * add missing refs
  * use std::for_each
  * use references
  * send trajectories
  * generate controller trajectories for a motion
  * Merge branch 'improvements' into 'humble-devel'
    Enhancement and fix issues
    See merge request app-tools/play_motion2!6
  * syntax fix
  * simplify check_joints_and_controllers
  * filter controller states function
  * function to list controllers
  * set default constructors
  * add use_sim_time argument
  * fix headers
  * store info, not trajectory
  * create MotionInfo for each motion


=== debian/control ===
Source: ros-humble-play-motion2
Section: misc
Priority: optional
Maintainer: Noel Jimenez <noel.jimenez@pal-robotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake-auto, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-index-cpp <!nocheck>, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-control-msgs, ros-humble-controller-manager <!nocheck>, ros-humble-controller-manager-msgs, ros-humble-hardware-interface <!nocheck>, ros-humble-joint-state-broadcaster <!nocheck>, ros-humble-joint-trajectory-controller <!nocheck>, ros-humble-launch-pal <!nocheck>, ros-humble-launch-ros <!nocheck>, ros-humble-launch-testing-ament-cmake <!nocheck>, ros-humble-lifecycle-msgs, ros-humble-play-motion2-msgs, ros-humble-pluginlib <!nocheck>, ros-humble-rclcpp, ros-humble-rclcpp-action, ros-humble-rclcpp-lifecycle, ros-humble-robot-state-publisher <!nocheck>, ros-humble-sensor-msgs, ros-humble-trajectory-msgs, ros-humble-xacro <!nocheck>, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-play-motion2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-control-msgs, ros-humble-controller-manager-msgs, ros-humble-lifecycle-msgs, ros-humble-play-motion2-msgs, ros-humble-rclcpp, ros-humble-rclcpp-action, ros-humble-rclcpp-lifecycle, ros-humble-sensor-msgs, ros-humble-trajectory-msgs, ros-humble-ros-workspace
Description: Play a pre-recorded motion on a robot

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-play-motion2//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install

## ros-humble-play-motion2 1.3.0

=== debian/changelog ===
ros-humble-play-motion2 (1.3.0-1bookworm) bookworm; urgency=high

  * Remove error log from exists function
  * Check the motion exists for isMotionReady service
  * Add missing option to overwrite when adding motion
  * Add option to run motions asynchronously
  * Create service functions for the PlayMotion2Client
  * Add run_motion executable
  * Add simple client for PlayMotion2
  * Add new motion key only if is not overwritten
  * Create services to add and remove motions
  * Add service to get the info of a motion
  * Contributors: Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Mon, 09 Sep 2024 16:00:00 -0000

ros-humble-play-motion2 (1.2.0-1bookworm) bookworm; urgency=high

  * Wait for robot description and semantic when using planning
  * Wait for the executor to be spinning for play_motion2_test
  * Contributors: Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Thu, 08 Aug 2024 16:00:00 -0000

ros-humble-play-motion2 (1.1.2-1bookworm) bookworm; urgency=high

  * Handle joint state not available in /joint_states topic
  * Contributors: Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Wed, 03 Jul 2024 16:00:00 -0000

ros-humble-play-motion2 (1.1.1-1bookworm) bookworm; urgency=high

  * fix joint name by replacing find_first_of function to find_last_of
  * Contributors: Aina Irisarri

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Thu, 25 Apr 2024 16:00:00 -0000

ros-humble-play-motion2 (1.1.0-1bookworm) bookworm; urgency=high

  * Fix comment
  * Add test deactivating unused controller while executing a motion
  * Fail on controller change only if it's used by the running motion
  * Cancel goals on failure
  * Change logging level for 'Motion failed' message
  * Invert loop to check changing controller properly
  * Contributors: Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Tue, 02 Apr 2024 16:00:00 -0000

ros-humble-play-motion2 (1.0.1-1bookworm) bookworm; urgency=high

  * Rename method perform_unplanned_motion to perform_motion
  * Skip approach when the joints are already in the first position
  * Contributors: Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Wed, 06 Mar 2024 16:00:00 -0000

ros-humble-play-motion2 (1.0.0-1bookworm) bookworm; urgency=high

  * Rename planner launch argument and update its config
  * Fix condition for checking planning groups parameter
  * Enhance loop condition
  * Enhance way of getting parameters
  * Store parameter names in constants
  * Remove unused method
  * Complete comment
  * Remove unnecessary variable all_joints_included
  * Fix condition when checking valid move groups
  * Update non-planned motion tests
  * Remove line jump from log
  * Add planning capability
  * Add logic for planning parameters
  * Create a MoveGroupInterfacePtr for each planning group
  * Parse planning related parameters
  * Include key in MotionInfo
  * Handle INVALID Result State
  * Remove unused function
  * Rename motion_info to info
  * Remove unused boolean variable
  * Delete commented code
  * Fix Result State type
  * Enable motion canceling
  * Use auto
  * Move all the execution logic to MotionPlanner
    Now the MotionPlanner is the responsible of sending the goals for
    performing the motions. As well the motion has been splitted in two
    parts: Approach and Motion
    The Approach part is the movement from the initial point to the first
    position, and the rest of the positions form the Motion
  * Get motion_planner parameters on constructor
  * Rename ApproachPlanner to MotionPlanner
  * Use play_motion2 node for ApproachPlanner
  * Update types
  * Contributors: Jordan Palacios, Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Tue, 27 Feb 2024 16:00:00 -0000

ros-humble-play-motion2 (0.0.15-1bookworm) bookworm; urgency=high

  * Change callback_group to MutuallyExclusive
    Reentrant callback group sometimes throws an unexpected runtime
    exception: 'Executing action client but nothing is ready'. It is caused
    because this type of callback group can execute different parts of the
    same callback concurrently.
  * Specify mutex type for unique_lock
  * Contributors: Aina Irisarri, Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Sun, 14 Jan 2024 16:00:00 -0000

ros-humble-play-motion2 (0.0.14-1bookworm) bookworm; urgency=high

  * Avoid exporting lifecycle_msgs dependency
  * Contributors: Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Sun, 07 Jan 2024 16:00:00 -0000

ros-humble-play-motion2 (0.0.13-1bookworm) bookworm; urgency=high

  * Rename launch argument for motions config
  * Add default approach_planner config
  * Add launch argument for approach_planner config
  * Fix approach planner parameters check condition
  * Avoid installing test configuration files
  * Join test config files
  * Fix motion_loader_test node name and params file
  * Fix parameters node names
  * Simplify controllers usage for testing
  * Create MotionLoader to replace helpers
  * Contributors: Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Wed, 13 Dec 2023 16:00:00 -0000

ros-humble-play-motion2 (0.0.12-1bookworm) bookworm; urgency=high

  * Add website tag
  * Contributors: Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Mon, 13 Nov 2023 16:00:00 -0000

ros-humble-play-motion2 (0.0.11-1bookworm) bookworm; urgency=high

  * Set use_sim_time false as default
  * Fix launch dependencies
  * Fix launch argument description
  * Contributors: Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Sun, 12 Nov 2023 16:00:00 -0000

ros-humble-play-motion2 (0.0.10-1bookworm) bookworm; urgency=high

  * Move ApproachPlanner to a different class
  * Contributors: Noel Jimenez

 -- Noel Jimenez <noel.jimenez@pal-robotics.com>  Sun, 01 Oct 2023 16:00:00 -0000

ros-humble-play-motion2 (0.0.9-1bookworm) bookworm; urgency=high



=== debian/control ===
Source: ros-humble-play-motion2
Section: misc
Priority: optional
Maintainer: Noel Jimenez <noel.jimenez@pal-robotics.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake-auto, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-index-cpp <!nocheck>, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-control-msgs, ros-humble-controller-manager <!nocheck>, ros-humble-controller-manager-msgs, ros-humble-hardware-interface <!nocheck>, ros-humble-joint-state-broadcaster <!nocheck>, ros-humble-joint-trajectory-controller <!nocheck>, ros-humble-launch-pal <!nocheck>, ros-humble-launch-testing-ament-cmake <!nocheck>, ros-humble-lifecycle-msgs, ros-humble-moveit-ros-planning-interface, ros-humble-play-motion2-msgs, ros-humble-pluginlib <!nocheck>, ros-humble-rclcpp, ros-humble-rclcpp-action, ros-humble-rclcpp-lifecycle, ros-humble-robot-state-publisher <!nocheck>, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-trajectory-msgs, ros-humble-xacro <!nocheck>, ros-humble-ros-workspace
Homepage: https://github.com/pal-robotics/play_motion2
Standards-Version: 3.9.2

Package: ros-humble-play-motion2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-control-msgs, ros-humble-controller-manager-msgs, ros-humble-launch, ros-humble-launch-ros, ros-humble-lifecycle-msgs, ros-humble-moveit-ros-planning-interface, ros-humble-play-motion2-msgs, ros-humble-rclcpp, ros-humble-rclcpp-action, ros-humble-rclcpp-lifecycle, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-trajectory-msgs, ros-humble-ros-workspace
Description: Play a pre-recorded motion on a robot

=== debian/rules ===
--- 
+++ 
@@ -57,7 +57,7 @@
 	# in the install tree and source it.  It will set things like
 	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
-	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-play-motion2//opt/ros/humble/lib/
+	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-play-motion2//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-play-motion2//opt/ros/humble/opt/play_motion2/lib/
 
 override_dh_auto_install:
 	# In case we're installing to a non-standard location, look for a setup.sh
